#!/usr/bin/perl
use Socket;
$sock_addr = 'S n a4 x8';
$hostname = '$ENV{HOST}';
($name,$aliases,$proto) = getprotobyname('tcp');
($name,$aliases,$type,$len,$thisaddr) = gethostbyname($hostname);
$port = 80;


$method = "GET";
$url    = "http://localhost:5963/";
($stat,$header,$content) = HTTPrequest($url,$method,"");

foreach(split(/(?:\015\012|\015|\012)/,$header)){
    print $_."\015\012" if(/^Content-Type:/i);
}
print "\015\012";
print $content;

sub HTTPrequest{
    my($url,$method,$req_body) = @_;
    my($path,$serv,$dir,$file,$stat,$header,$content,$req_str);

    $url =~ m%http://(.*?)((?:/.*)*/)(.*)%;
    ($serv,$dir,$file) = ($1,$2,$3);
    $path = $dir.$file;

    if($serv =~ /(.*):(\d+)$/){
	$serv = $1;
	$port = $2;
    }

    $req_str  = "$method $path HTTP/1.0\r\n";
    $req_str .= "User-Agent: $agentname\r\n";
    $req_str .= "Content-Length: ".length($req_body)."\r\n" if($req_body);
    $req_str .= "Connection: close\r\n";
    $req_str .= "\r\n";
    $req_str .= "$req_body\r\n" if $req_body;

    eval{ local $SIG{ALRM} = sub { die "DNS timeout" };
	  alarm($TIMEOUT);
	  ($name,$aliases,$port)
	      = getservbyname($port,'tcp') unless $port =~/^\d+$/;;
	  ($name,$aliases,$type,$len,$thataddr) = gethostbyname($serv);
	  alarm(0);
      };
    if($@ ne ""){print LOG $@;print STDERR $@;return 0}
    
    my $that = pack($sock_addr,&AF_INET,$port,$thataddr);
    my $this = pack($sock_addr,&AF_INET,0,$thisaddr);
    
    eval{ local $SIG{ALRM} = sub { die "HTTP timeout" };
	  alarm($TIMEOUT);
	  socket(S,&PF_INET,&SOCK_STREAM,$proto) or die "cannot get a socket";
	  bind(S,$this) or die "cannot bind socket";
	  connect(S,$that) or die "cannot connect socket";
	  
	  my($oldselect) = select;
	  select(S);$| = 1;
	  print S $req_str;
	  
	  print LOG "\n";
	  print LOG $req_str;
	  
	  select($oldselect);

	  $header = <S>;
	  $header =~ /(\d\d\d)/;
	  $stat = $1;

	  while(<S>){
	      alarm($TIMEOUT);
	      $header .= $_;
	      last if(/^\015\012$/ || /^\015$/ || /^\012$/);
	  }
	  while(<S>){
	      alarm($TIMEOUT);
	      $content .= $_;
	  }
	  close(S);
	  alarm(0);
      };
    if($@ ne ""){close(S);print LOG $@;print STDERR $@;return 0,$header,$content}
    else{print LOG "$stat done.\n";}

    my($gunziped);
    foreach(split(/(?:\015\012|\015|\012)/,$header)){
	if(/^Content-Encoding:/i && /gzip/ && !$gunziped){
	    $content = gunzip($content);
	    print LOG "gunzip content done.\n";
	    $gunziped = 1;
	}
    }
    return ($stat,$header,$content);
}
